%STATUS: UNTESTED

%This is my implementation of plant viewer
%
%basically involves walking through the plant onle symbol at a time, for
%every "F" drawing some line, ant then continue to walk
%
%is a large case testing


%pass in both the current plant and
function plant = my_plant_view(plants, axes)

gca = axes;

hold on

%%%%%%%%%
% Note on 3d plots:
% There are 6 degrees of freedom in 3d; there are the position vectors (x,y,z)
% and the viewing vectors (theta, phi) which can describe a 3d vector;
% consequently, only 5 variables are needed to account for this
%
% position change occurs with 'F', view change occurs with '+ - /+ /-'
%%%%%%%%

for ww = 1:numel(plants)

    plant = plants(ww);


    x = plant.pos(1);
    y = plant.pos(2);
    z = 0; %always growing from ground
    theta = 0;%(pointing out along x-axis; stuck to x-y plane
    phi = 0;%(pointing up in z dir)

    theta_change = pi/4;
    phi_change = pi/4;

    curstring = plant.curstring;

    stack.x = [];
    stack.y = [];
    stack.z = [];
    stack.theta = [];
    stack.phi = [];

    lighting NONE;

    %fprintf('\nThe current string is:\n%s', curstring);

    %disp('I am starting the drawing\n');


    %so goes through each component in curstring
    %note, since ii is read only (can't change ii within, then use while loop)


    total = numel(curstring);
    ii =1;

    while (ii <= total)

        curchar = curstring(ii);

        switch curchar
            case 'F'

                %find closing }
                closers = find(curstring == '}');
                next_closers = closers(find(closers > ii));
                next_closer = next_closers(1);

                length = eval(curstring((ii + 2):(next_closer - 1))); %some value

                if (length > 0)
                    x0 = x;
                    y0 = y;
                    z0 = z;

                    %calculate where the endpoints for the segment will be
                    x = round((length * sin(phi))*cos(theta)) + x0;
                    y = round((length * sin(phi))*sin(theta)) + y0;
                    z = round((length * cos(phi))) + z0;

                    %draw a line
                    h = line([x0 x], [y0 y], [z0 z]);

                    set(h, 'color', plant.color/255);
                    set(h, 'linewidth', length * .5); %longer = thicker

                    clear x0 y0 z0 h

                end

                ii = 1 + next_closer;

            case '+'
                theta = theta + theta_change;
                ii = ii + 1;

            case '-'
                theta = theta - theta_change;
                ii = ii + 1;

            case '/'
                %need to increment to skip over +,-

                ii = ii + 1;
                if (curstring(ii) == '+')
                    phi = phi + phi_change;

                elseif (curstring(ii) == '-')
                    phi = phi - phi_change;
                end
                ii = ii+1;

                %This is an artifact from thinking roll needed to be seperately accounted for; is not useful
            case '$'
                %want to skip over +,- immediately afterwards
                ii = ii+1;

            case '['
                %add current values to the stack
                stack.x = [stack.x x];
                stack.y = [stack.y y];
                stack.z = [stack.z z];
                stack.theta = [stack.theta theta];
                stack.phi = [stack.phi phi];
                ii = ii + 1;

            case ']'
                %first copy all values, then delete from the stack
                x = stack.x(end);
                y = stack.y(end);
                z = stack.z(end);
                theta = stack.theta(end);
                phi = stack.phi(end);

                stack.x = stack.x(1:(end-1));
                stack.y = stack.y(1:(end-1));
                stack.z = stack.z(1:(end-1));
                stack.theta = stack.theta(1:(end-1));
                stack.phi = stack.phi(1:(end-1));
                ii = ii +1;

            otherwise
                fprintf('ERROR:  ILLEGAL CHAR:  %c', curstring(ii));
                ii = ii + 1;


        end

    end
end


xlabel('x-axis');
ylabel('y-axis');
zlabel('z-axis');

%title('Plant Viewer 0.01')






% %
% %
% % for ii = 1:numel(curstring)
% %
% %     curchar = curstring(ii);
% %
% %     switch curchar
% %         case 'F'
% %             length = str2num(curstring(ii + 2));
% %
% %             x0 = x;
% %             y0 = y;
% %             z0 = z;
% %
% %             %calculate where the endpoints for the segment will be
% %             x = round((length * cos(phi))*cos(theta)) + x0;
% %             y = round((length * cos(phi))*sin(theta)) + y0;
% %             z = round((length * sin(phi))) + z0;
% %
% %             %draw a line
% %             h = line([x0 x], [y0 y], [z0 z]);
% %
% %             set(h, 'color', plant.color);
% %             set(h, 'linewidth', length * .5); %longer = thicker
% %
% %             ii = ii + 3; %3 not 4 --> will increment once this case ends
% %
% %         case '+'
% %             theta = theta + theta_change;
% %
% %         case '-'
% %             theta = theta - theta_change;
% %
% %         case '/'
% %             %need to increment to skip over +,-
% %             ii = ii+1;
% %
% %             if (curstring(ii) == '+')
% %                 phi = phi + phi_change;
% %
% %             elseif (curstring(ii) == '-')
% %                 phi = phi - phi_change;
% %             end
% %
% %             %This is an artifact from thinking roll needed to be seperately accounted for; is not useful
% %         case '$'
% %             %want to skip over +,- immediately afterwards
% %             ii = ii+1;
% %
% %         case '['
% %             %add current values to the stack
% %             stack.x = [stack.x x];
% %             stack.y = [stack.y y];
% %             stack.z = [stack.z z];
% %             stack.theta = [stack.theta theta];
% %             stack.phi = [stack.phi phi];
% %
% %         case ']'
% %             %first copy all values, then delete from the stack
% %             x = stack.x(end);
% %             y = stack.y(end);
% %             z = stack.z(end);
% %             theta = stack.theta(end);
% %             phi = stack.phi(end);
% %
% %             stack.x = stack.x(1:(end-1));
% %             stack.y = stack.y(1:(end-1));
% %             stack.z = stack.z(1:(end-1));
% %             stack.theta = stack.theta(1:(end-1));
% %             stack.phi = stack.phi(1:(end-1));
% %
% %         otherwise
% %
% %
% %     end
% %
% % end




%find counts nonzeroelements, so argument inside find makes a temp array
%where 1 when comparison works, 0 when not
% %
% % %the color data in cdata is in range 0 - 255 but plant.color from 0 - 1
% % curframe = getframe(gcf);
% % numexposedpixels = numel(find(curframe.cdata(:,:,1) == round(plant.color(1)*255) & curframe.cdata(:,:,2) == round(plant.color(2)*255) & curframe.cdata(:,:,3) == round(plant.color(3)*255)))
% %
% % plant.energy.numexppixel = numexposedpixels;
% % %
% numel(find(curframe.cdata(:,:,1) == round(plant.color(1)*255)))
% numel(find(curframe.cdata(:,:,2) == round(plant.color(2)*255)))
% numel(find(curframe.cdata(:,:,3) == round(plant.color(3)*255)))