% Part of Tree  Chris Quinn   cjq3@cornell.edu   last updated 02.28.06

% STATUS:   Working ! (although was tested seperately

%to test, make sure sent percentage chances to 100 so can walk through


%note, since it is not the case that resembles DNA with every 3 bits
%something useful, of 4 possibilities all same class of bit, but instead
%angles and 'Fs' etc., will not be morphing in sense of randomly mutating a
%single bit, but will instead be a little more algorithmic

%%%%%%%%%%%%%%%%%%%%%%%%%%
%%  MY CURRENT DEFINITION OF "MORPH"
%%
%%  1) an angle can be deleted or added
%%  2) an angle can be changed in its plane (+ --> -, not /+ --> -)
%%  3) a length can be shortened or lengthened by a small value (not
%%  physically realistic to add orders of magnitude
%%  4) a growth can be deleted
%%  5) a growth can be added
%%
%%  :: All deletions and changes must occur before additions
%%
%%


function [theplants] = morph(theplants, percent_morph)

%%USER VARIABLES
maximumpercentgrowth = .5; %at most any branch can grow or shrink by 100%

maximumpercentgrowthsadded = 1; %at most, i.e if percent_morph = 100, round(1*num('F')) can be added

maximumpercentanglesadded = 1; %at most, 1*current#angles can be added, seperately deal with + and /+

%%%chancewilladdgrowth = .5; %add 1/2 of the growths are alloted  _--->
%%%percent morph takes care of this


%errordlg('!!!  MORPH IS NOT IN PLACE !!!');

%will set a maximum threshold of 0 <-->100%
if (percent_morph < 0)
    percent_morph = 0;
elseif(percent_morph > 100)
    percent_morph = 100
end







for rr = 1:numel(theplants)

    currule = theplants{rr}.rule;



    %%%% FIRST CHECK THAT RULE IS PROPERLY BALANCED WITH {} AND []

    left_curls = find(currule == '{');
    right_curls = find(currule == '}');
    left_brace = find(currule == '[');
    right_brace = find(currule == ']');

    badones = [find(left_curls > right_curls) find(left_brace > right_brace)];

    if (numel(badones) > 0)
        errordlg('the strings {} or [] are not balanced properly');
        return;
    end





    %%%%%%%%%%%%%%  1   &&   2 %%%%%%%%%%%%%%%%%%

    %XX%first edit all angles, both in theta and phi
    %XXdo seperate phi and theta initially, do find(currule(find(currule
    %XX== '+' .. '-') - 1 ~= '/' & (currule== '+' .. '-')

    %find angles not in between curly braces
    allsymbols = find(currule == '+' | currule == '-' );

    %determine which of the 'allsymbols' are angles

    notfinished = 1; %because cannot change the running variable in a for loop and expect value to hold when starts next loop
    pos = 1;

    if (numel(allsymbols) > 1)
        while(notfinished)

            if(numel(find(left_curls<allsymbols(pos))) ~= numel(find(right_curls<allsymbols(pos))))
                %then delete symbol from the list

                allsymbols = [allsymbols(1:(pos-1)) allsymbols((pos+1):end)];

            else
                pos = pos + 1;
            end


            if (pos > numel(allsymbols))
                notfinished = 0;
            end
        end

    end
    angles = allsymbols;



    %%NOT SURE IF THIS IS CORRECT
    %for addition
    phi_angles = numel(find(currule([angles(find(angles>1))-1]) == '/')); %do not want to simply count '/' as an error might lead to '//+'
    theta_angles = numel(angles) - phi_angles;


    %First delete angles, then add, since it would not make sense to
    %delete ones just made
    %So angles can either be changed or deleted
    for uu = 1:numel(angles)

        if (rand <= percent_morph/100)
            %half chance deleted, half chance changed

            if (.5 >= rand) %delete


                if(angles(uu)>1 && currule(angles(uu) - 1) == '/')
                    currule = [currule(1:(angles(uu) - 2)) currule((angles(uu) + 1):end)];
                    angles = angles - 2;

                else


                    currule = [currule(1:(angles(uu) - 1)) currule((angles(uu) + 1):end)];

                    angles = angles - 1;
                end

            else    %change

                if (currule(angles(uu)) == '+')
                    currule(angles(uu)) = '-';
                else
                    currule(angles(uu)) = '+';
                end
            end
        end
    end


    %fprintf('\nDeleted/Changed Angles:\n%s\n', currule);

    %% ADD Angles

    %first add some thetas and then phis



    maxthetas_canadd = round(theta_angles * maximumpercentanglesadded);
    %and will add 'F{n}'
    if (maxthetas_canadd == 0)
        maxthetas_canadd = 1;
    end
    

    for ww = 1:maxthetas_canadd

        if (rand < percent_morph/100)

            %randomly pick a position, and while its in a {} pick
            %another  (count # of {} to left, if balanced)
            %
            %  1) not in between F{...}
            %
            %



            inbetweenbraces = 1; % so can start a loop


            while(inbetweenbraces)

                new_position = ceil(rand*numel(currule));

                if(new_position ~=1 & numel(currule)>0)

                    left_braces = find(currule == '{');
                    left_braces = left_braces(find(left_braces < new_position)); %less than since pushing char at that spot to the right

                    right_braces = find(currule == '}');
                    right_braces = right_braces(find(right_braces < new_position)); %less than since pushing char at that spot to the right

                    %cannot be between 'F{...}' or '/+'
                    if (numel(left_braces) == numel(right_braces) & (currule(new_position - 1) ~= 'F') & (currule(new_position - 1) ~= '/'))
                        inbetweenbraces = 0;
                    else
                        inbetweenbraces = 1;
                        %fprintf('\n %d is still in between curly braces or in the way', new_position);
                    end

                else
                    inbetweenbraces = 0;

                end
            end

            angle = '-';
            if (rand > .5)
                angle = '+';
            end


            %%NOW ADD THE Theta Angle

            if(new_position~=1)
                currule = [currule(1:(new_position-1)) angle currule(new_position:end)];

            else
                currule = [angle currule(new_position:end)];
            end

        end




    end

    %fprintf('\nAdding  Theta Angles:\n%s\n', currule);



    %%%%%%%      ADD   PHI ANGLES  %%%%%%%%%


    maxphis_canadd = round(phi_angles * maximumpercentanglesadded);
    %and will add 'F{n}'

    for ww = 1:maxphis_canadd

        if (rand < percent_morph/100)

            %randomly pick a position, and while its in a {} pick
            %another  (count # of {} to left, if balanced)
            %
            %  1) not in between F{...}
            %
            %
            inbetweenbraces = 1; % so can start a loop


            while(inbetweenbraces)

                new_position = ceil(rand*numel(currule));

                if(new_position ~= 1)

                    left_braces = find(currule == '{');
                    left_braces = left_braces(find(left_braces < new_position)); %less than since pushing char at that spot to the right

                    right_braces = find(currule == '}');
                    right_braces = right_braces(find(right_braces < new_position)); %less than since pushing char at that spot to the right

                    %cannot be between 'F{...}' or '/+'
                    if (numel(left_braces) == numel(right_braces) & (currule(new_position - 1) ~= 'F') & (currule(new_position - 1) ~= '/'))
                        inbetweenbraces = 0;
                    else
                        inbetweenbraces = 1;
                        %fprintf('/n %d is still in between curly braces or in the way', new_position);
                    end


                else
                    inbetweenbraces = 0;
                end
            end

            angle = '/-';
            if (rand > .5)
                angle = '/+';
            end


            %%NOW ADD THE Theta Angle

            if(new_position ~=1)
                currule = [currule(1:(new_position-1)) angle currule(new_position:end)];
            else
                currule = [angle currule(new_position:end)];
            end

        end

    end


    clear angle left_braces right_braces new_position notintheway ww maxthetas_canadd maxphis_canadd

    %fprintf('\nAdding Phi Angles:\n%s\n', currule);






    %%  3) a length can be shortened or lengthened by a small value (not
    %%  physically realistic to add orders of magnitude
    %now go through and change lengths

    %will not assume any length --> can be 'n-2' or 'n-5' or '.8*n'

    curlies = find(currule == '{');

    for mm = 1:numel(curlies) %so for each value


        if (rand <= percent_morph/100)
            %then length change will be random * maximumpercentgrowth;

            %first get the corresponding closing brace

            allclosers = find(currule == '}');
            nextclosers = allclosers(find(allclosers > curlies(mm)));
            nextcloser = nextclosers(1);


            %current length = 'n - 4' or '.2*(n-6)' or something like
            %that
            curlength = currule((curlies(mm) + 1):(nextcloser - 1));

            newlength = 'it did not work'; %error checking

            if (rand >.5) %lengthen

                newlength = sprintf('%g*(%s)', (1-maximumpercentgrowth), curlength);

            else
                newlength = sprintf('%g*(%s)', (1+maximumpercentgrowth), curlength);

            end

            %put new length in the place --> in string

            currule = [currule(1:curlies(mm)) newlength currule(nextcloser:end)];


            %find how much length changed so can adjust the later ones
            changeinstring = numel(newlength) - numel(curlength);

            %curlies = find(currule == '{');

            curlies = curlies + changeinstring;


        end

    end
    clear mm curlies changeinstring newlength nextcloser nextclosers

    %fprintf('\nChanging Length:\n%s\n', currule);




    %################  GROWTH ADDITION AND DELETION ##############


    %%  4) a growth can be deleted
    %maximumpercentgrowthsadded

    Fs = find(currule == 'F');



    %so do not delete ones just added, DELETE FIRST

    %%%   DELETE
    for pp = 1:numel(Fs)

        if (rand <= percent_morph/100)

            %DELETE
            %first find position of next '}'
            all_rightbraces = find(currule == '}');
            rightbraces = all_rightbraces(find(all_rightbraces > Fs(pp)));
            rightbrace = rightbraces(1);


            %MODIFY currule

            currule = [currule(1:(Fs(pp) - 1)) currule((rightbrace + 1):end)];




            %MODIFY Fs array

            %need to shift all position values of Fs over to left of
            %space deleted  /+F{n}F{n}/+

            Fs = Fs - (rightbrace + 1 -Fs(pp));


        end

    end
    clear pp all_rightbraces rightbraces rightbrace

    %fprintf('\nDeleting Growth:\n%s\n', currule);


    %%%%  NOW ADD GROWTHS

    maxgrowthscanadd = round(numel(Fs) * maximumpercentgrowthsadded);
    %and will add 'F{n}'
    
    if (maxgrowthscanadd == 0)
        maxgrowthscanadd = 1;
    end
    

    for ww = 1:maxgrowthscanadd

        if (rand < percent_morph/100)

            %randomly pick a position, and while its in a {} pick
            %another  (count # of {} to left, if balanced)

            inbetweenbraces = 1; % so can start a loop

            while(inbetweenbraces)

                new_position = ceil(rand*numel(currule));
                
              
                if (new_position ~=1 & numel(currule)>0)
                    left_braces = find(currule == '{');
                    left_braces = left_braces(find(left_braces < new_position)); %less than since pushing char at that spot to the right

                    right_braces = find(currule == '}');
                    right_braces = right_braces(find(right_braces < new_position)); %less than since pushing char at that spot to the right


                    %cannot be between 'F{...}' or '/+'
                    if (numel(left_braces) == numel(right_braces))

                        if(numel(left_braces) == 0 & (currule(new_position - 1) ~= 'F')& (currule(new_position - 1) ~= '/'))
                            inbetweenbraces = 0;
                        else
                            inbetweenbraces = 1;
                            %fprintf('\n %d is still in between curly braces or in the way', new_position);
                        end


                    end
                else
                    inbetweenbraces = 0;
                end

            end


            %%NOW ADD THE GROWTH
            if (new_position ~=1)
                currule = [currule(1:(new_position-1)) 'F{n}' currule(new_position:end)];


            else
                currule = ['F{n}' currule(new_position:end)];

            end
        end


    end

    %fprintf('\nAdding Growth:\n%s\n', currule);





    theplants{rr}.rule = currule;





end